package luluteam.wxpay.util;

import org.apache.commons.lang3.Validate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

/**
 * Created by Hyman on 2016/4/25.
 */
public class SpringContextHolder implements ApplicationContextAware {

    private static ApplicationContext applicationContext = null;
    private static Logger logger = LoggerFactory.getLogger(SpringContextHolder.class);

    /**
     * ȡô洢ھ̬еApplicationContext.
     */
    public static ApplicationContext getApplicationContext() {
        assertContextInjected();
        return applicationContext;
    }

    /**
     * Ӿ̬applicationContextȡBean, ԶתΪֵ.
     */
    @SuppressWarnings("unchecked")
    public static <T> T getBean(String name) {
        assertContextInjected();
        return (T) applicationContext.getBean(name);
    }

    /**
     * Ӿ̬applicationContextȡBean, ԶתΪֵ.
     */
    public static <T> T getBean(Class<T> requiredType) {
        assertContextInjected();
        return applicationContext.getBean(requiredType);
    }

    /**
     * SpringContextHolderеApplicationContextΪNull.
     */
    public static void clearHolder() {
        logger.debug("SpringContextHolderеApplicationContext:"
                + applicationContext);
        applicationContext = null;
    }

    /**
     * ʵApplicationContextAwareӿ, עContext̬.
     */
    public void setApplicationContext(ApplicationContext applicationContext)
            throws BeansException {

    }

    /**
     * ʵDisposableBeanӿ, Contextرʱ̬.
     */
    public void destroy() throws Exception {
        SpringContextHolder.clearHolder();
    }

    /**
     * ApplicationContextΪ.
     */
    private static void assertContextInjected() {
        Validate.validState(applicationContext == null, "applicationContextΪգapplicationContext.xmlSpringApplicationContext");
    }

}

